#include<math.h>
#include <AccelStepper.h>
#include <MultiStepper.h>

double X0;
double Y0;
double OMEGA;

double Xa;
double Ya;
double Xb;
double Yb;
double Xc;
double Yc;
double Xp;
double Yp;
double Xq;
double Yq;
double Xr;
double Yr;
double Rf;

double  ab1;
double  ab2;
double ab3;
double  bc1;
double  bc2;
double  bc3;
double  co1;
double  co2;
double  co3;
double  Rm;
double  H;


double E1;
double E2;
double E3;
double E4;
double E5;
double E6;
double E7;
double E8;
double E9;
double E10;
double E11;
double E12;

double A1x;
double A2x;
double A3x;
double B1x;
double B2x;
double B3x;
double C1x;
double C2x;
double C3x;
double A1y;
double A2y;
double A3y;
double B1y;
double B2y;
double B3y;
double C1y;
double C2y;
double C3y;
double RA;

double OMEGA1;
double OMEGA2;
double OMEGA3;
double NU1;
double NU2;
double NU3;
double FI1;
double FI2;
double FI3;
double FI1n;
double FI2n;
double FI3n;
double FI1final;
double FI2final;
double FI3final;
double FI1comp;
double FI2comp;
double FI3comp;
double FI1acu;
double FI2acu;
double FI3acu;

double  OMEGAcont;
double OMEGAcomp;
double  X0comp;
double Y0comp;

double Finalsteps1;
double Finalsteps2;
double Finalsteps3;
double Stepdelay;
double Xjoystick;
double Yjoystick;

long gotoposition[3]; // to store the target positions for each stepper motor (en este caso 3)

const int SWjoystick = 10;
const int Dir1 = 9;
const int Steps1 = 8;
const int Dir2 = 7;
const int Steps2 = 6;
const int Dir3 = 5;
const int Steps3 = 4;

double l_1i;
double l_2i;
double l_3i;
double theta_up;
double theta_down;
double thetas[]= {theta_up, theta_down};
  
double a_1x;
double a_2x;
double a_3x;
double a_1y;
double a_2y;
double a_3y;
double psi_1;
double psi_2;
double psi_3;

double c_ix;
double c_iy;
double c_1x;
double c_1y;
double c_2x;
double c_2y;
double c_3x;
double c_3y;


char mensaje;

AccelStepper stepper1(1, 4, 5); // (Typeof driver: with 2 pins, STEP, DIR)
AccelStepper stepper2(1, 6, 7);
AccelStepper stepper3(1, 8, 9);

MultiStepper steppersControl;  // Create instance of MultiStepper


void setup()
{
  stepper1.setMaxSpeed(100); // Set maximum speed value for the stepper
  stepper2.setMaxSpeed(100);
  stepper3.setMaxSpeed(100);

  stepper1.setAcceleration(10);
  stepper2.setAcceleration(10);
  stepper3.setAcceleration(10);

  stepper1.setSpeed(50);
  stepper2.setSpeed(50);
  stepper3.setSpeed(50);
  
  // Adding the 3 steppers to the steppersControl instance for multi stepper control
  steppersControl.addStepper(stepper1);
  steppersControl.addStepper(stepper2);
  steppersControl.addStepper(stepper3);
 
  pinMode(SWjoystick, INPUT_PULLUP);
  pinMode(X0, INPUT);
  pinMode(Y0, INPUT);
  pinMode(Dir1, OUTPUT);
  pinMode(Steps1, OUTPUT);
  pinMode(Dir2, OUTPUT);
  pinMode(Steps2, OUTPUT);
  pinMode(Dir3, OUTPUT);
  pinMode(Steps3, OUTPUT);

  X0=0;
  Y0=0;
  OMEGA=0;
  
  OMEGAcont=0;
  
  ab1 = 0.15;
  ab2 = ab1;
  ab3 = ab1;
  l_1i = ab1;
  bc1 = 0.15;
  bc2 = bc1;
  bc3 = bc1;
  l_2i = bc1;
  co1 = 0.15;
  co2 = co1;
  co3 = co1;
  l_3i = co1;
  
  Rf = 0.175;
  RA = 0.2074;
  Rm = 0.025;
  H = Rm* (sqrt(3));
 
  Xp =  RA*(cos(radians(120))); //el coseno de 120 es negativo
  Yp = -RA*(sin(radians(120)));
  Xq = -RA*(cos(radians(120))); 
  Yq = -RA*(sin(radians(120)));
  Xr = 0;
  Yr = RA;

        //motor 1
        psi_1 = 210;
        a_1x = Xp;
        a_1y = Yp;

        //motor 2
        psi_2 =  psi_1 + 120;
        a_2x = Xq;
        a_2y = Yq;
        
       //motor 3
        psi_3 = psi_1 - 120;
        a_3x = Xr;
        a_3y = Yr;


  FI1comp= 35.12; 
  FI2comp= 6.99;
  FI3comp= 191.06;

  FI1acu=0;
  FI2acu=0;
  FI3acu=0;
  
  int  Stepdelay = 5000; //AJUSTE DE VELOCIDAD para los motores cuando no se usa la libreria ACCELSTEPPER
  Serial.begin(9600);
  
}

void loop()
{ 
  Stepdelay=5000000;
  
  X0comp=X0;
  Y0comp=Y0;
  OMEGAcomp=OMEGA;

  while(X0==X0comp && Y0==Y0comp && OMEGA==OMEGAcomp)
  
  {
    /* PARA MANEJAR CON JOYSTICK CONTROL DIRECTO
      if (digitalRead (SWjoystick)==HIGH)
      {
      OMEGAcont = OMEGAcont;
      }
      else
      {
      OMEGAcont = OMEGAcont+1 ;
      }

      if (OMEGAcont >= 0 && OMEGAcont <= 30)
      {
      OMEGA=OMEGAcont;
      }
      else if (OMEGAcont> 30 && OMEGAcont <= 60)
      {
      OMEGA=60-OMEGAcont;
      }
      else if (OMEGAcont > 60 && OMEGAcont <= 90)
      {
      OMEGA=OMEGAcont-60;
      }
      else if (OMEGAcont > 90 && OMEGAcont <= 120)
      {
      OMEGA=120-OMEGAcont;
      }
      else if (OMEGAcont > 120 && OMEGAcont <= 150)
      {
      OMEGA=OMEGAcont-120;
      }
      else if (OMEGAcont > 150 && OMEGAcont <= 180)
      {
      OMEGA=180-OMEGAcont;
      }
      else if (OMEGAcont > 180 && OMEGAcont <= 210)
      {
      OMEGA=OMEGAcont-180;
      }
      else if (OMEGAcont > 240 && OMEGAcont <= 270)
      {
      OMEGA=240-OMEGAcont;
      }
      else if (OMEGAcont > 270 && OMEGAcont <= 300)
      {
      OMEGA=OMEGAcont-240;
      }
      else if (OMEGAcont > 300 && OMEGAcont <= 330)
      {
      OMEGA=300-OMEGAcont;
      }
      else if (OMEGAcont > 330 && OMEGAcont <= 360)
      {
      OMEGA=OMEGAcont-300;
      }
      else
      {
      Serial.println("Error: incorrect value of FI, edge limit reached");
      Serial.println("Restart power");
      while (1) {} //se para el programa
      }
    

    Xjoystick = analogRead(A0);      // lectura de valor de eje x
    
      if (Xjoystick >= 0 && Xjoystick < 300)
      {
      X0=X0+0.0025;
      }
      else
      {
      int X0 = X0;
      }

      if (Xjoystick > 700 && Xjoystick <= 1023)
      {
      X0=X0-0.0025;
      }
      else
      {
      int X0 = X0;
      }
    
    Yjoystick = analogRead(A1);     // lectura de valor de eje y
    if (Yjoystick >= 0 && Yjoystick < 300)
      {
       Y0=Y0-0.0025;
      }
      else
      {
       int Y0 = Y0;
      }
      if (Yjoystick > 700 && Yjoystick <= 1023)
      {
       Y0=Y0+0.0025;
      }
      else
      {
       int Y0 = Y0;
      }
  */
  //////////////////////////////////////////////////////////////
  
//    PARA MANEJAR CON JOYSTICK A POSICIONES FIJAS
       Xjoystick = analogRead(A0);      // lectura de valor de eje x
       Yjoystick = analogRead(A1);     // lectura de valor de eje y
      if (digitalRead (SWjoystick)==HIGH)
      {     
      OMEGA = OMEGA ; 
      X0 = X0;
      Y0 = Y0;
      }
      else
      {
         X0=0;
         Y0=0;
         OMEGA=0;
      }
    
      if (Xjoystick >= 0 && Xjoystick < 300)
      {
         X0=0;
         Y0=0;
         OMEGA=2;
      }
       else
      {
      OMEGA = OMEGA ; 
      X0 = X0;
      Y0 = Y0;
      }
      if (Xjoystick > 700 && Xjoystick <= 1023)
      {
         X0=-0.010;
         Y0=-0.010;
         OMEGA=0;
      }
        else
      {
      OMEGA = OMEGA ; 
      X0 = X0;
      Y0 = Y0;
      }
    
 
    if (Yjoystick >= 0 && Yjoystick < 300)
      {
        X0=-0.005;
   Y0=0.002;
   OMEGA=0;
      }
         else
      {
      OMEGA = OMEGA ; 
      X0 = X0;
      Y0 = Y0;
      }
    
      if (Yjoystick > 700 && Yjoystick <= 1023)
      {
   X0=0;
   Y0=0;
   OMEGA=10;
      }
        else
      {
      OMEGA = OMEGA ; 
      X0 = X0;
      Y0 = Y0;
      }
  
  /*
  ///////////////////////////////////////////////////////////////
  //PARA MANEJAR CON TECLADO
  
   if(Serial.available()>0)
    mensaje=Serial.read();
 if (mensaje=='0') 
  {
   X0=0;
   Y0=0;
   OMEGA=0;
  } 
  
  if (mensaje=='1') 
  {
   X0=0;
   Y0=0;
   OMEGA=10;
 
  } 
 
  if (mensaje=='2') 
  {
   X0=-0.005;
   Y0=0.002;
   OMEGA=0;
  } 

  if (mensaje=='3') 
  {
   X0=0.001;
   Y0=-0.020;
   OMEGA=0;
  } 

  else
  {
  OMEGA = OMEGA ; 
  X0 = X0;
  Y0 = Y0;
  }
  */
 
  
  }
  

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////7 


                    c_1x = X0 + l_3i*cos(radians(OMEGA+psi_1));
                    c_1y = Y0 + l_3i*sin(radians(OMEGA+psi_1));

                    E1 = 2*(c_1x - a_1x)*l_1i;
                    E2 = 2*(c_1y - a_1y)*l_1i;
                    E3 = sq(l_2i) - sq(l_1i) - sq((c_1x - a_1x)) - sq((c_1y - a_1y));
                
                    FI1 = (180/PI)*2*atan(radians( (-E2 + sqrt(sq(E1) + sq(E2) - sq(E3)))) / radians((E3-E1)) );
                    FI1n = (180/PI)*2*atan(radians( (-E2 - sqrt(sq(E1) + sq(E2) - sq(E3)))) / radians((E3-E1)) );              
                  
                    c_2x = X0 + l_3i*cos(radians(OMEGA+psi_2));
                    c_2y = Y0 + l_3i*sin(radians(OMEGA+psi_2));

                    E4 = 2*(c_2x - a_2x)*l_1i;
                    E5 = 2*(c_2y - a_2y)*l_1i;
                    E6 = sq(l_2i) - sq(l_1i) - sq((c_2x - a_2x)) - sq((c_2y - a_2y));
                
                    FI2 = (180/PI)*2*atan(radians( (-E5 + sqrt(sq(E4) + sq(E5) - sq(E6)))) / radians((E6-E4)) );
                    FI2n = (180/PI)*2*atan(radians( (-E5 - sqrt(sq(E4) + sq(E5) - sq(E6)))) / radians((E6-E4)) );   

                    c_3x = X0 + l_3i*cos(radians(OMEGA+psi_3));
                    c_3y = Y0 + l_3i*sin(radians(OMEGA+psi_3));

                    E7 = 2*(c_3x - a_3x)*l_1i;
                    E8 = 2*(c_3y - a_3y)*l_1i;
                    E9 = sq(l_2i) - sq(l_1i) - sq((c_3x - a_3x)) - sq((c_3y - a_3y));
                
                    FI3 = (180/PI)*2*atan(radians( (-E8 + sqrt(sq(E7) + sq(E8) - sq(E9)))) / radians((E9-E7)) ) ;
                    FI3n = (180/PI)*2*atan(radians( (-E8 - sqrt(sq(E7) + sq(E8) - sq(E9)))) / radians((E9-E7)) );   

             if (FI1 < 0)
             {
              FI1=360 + FI1;
              FI2=FI2;
              FI3=FI3;
             }
                
            if (FI3 < 0)
            {
              FI1=FI1;
              FI2=FI2;
              FI3=360 + FI3;
            }

            else
            {
              FI1=FI1;
              FI2=FI2;
              FI3=FI3;
            }
   
   /* OTRO TIPO DE RESOLUCIÓN CINEMÁTICA
      
    Xa = X0 - ((H/(sqrt(3)))*(cos(30+OMEGA)));
    Ya = Y0 - ((H/(sqrt(3)))*(sin(30+OMEGA)));

    Xb = Xa + (H * (cos(OMEGA)));
    Yb = Ya + (H * (sin(OMEGA)));
   
    Xc = Xa + (H * (cos(OMEGA+60))); //puede ser PI/3 si se escribe en radianes
    Yc = Ya + (H * (sin(OMEGA+60)));

    E1 = -2 * Ya * ab1;
    E2 = -2 * Xa * ab1;
    E3 = (sq(Xa)) + (sq(Ya)) + (sq(ab1)) - (sq(bc1));
    E4 = -(2 * Ya * ab2) + (2 * Yq * ab2) - (2 * H * ab2 * (sin(OMEGA)));
    E5 = -(2 * Xa * ab2) + (2 * Xq * ab2) - (2 * H * ab2 * (cos(OMEGA)));
    E6 = (sq(Xa)) + (sq(Ya)) - (2 * Xa * Xq) + (sq(Xq)) + (sq(Yq)) + (sq(H)) + (sq(ab2)) - (sq(bc2)) + (2 * Xa * H * (cos(OMEGA))) + (2 * Ya * H * (sin(OMEGA))) - (2 * H * Xq * (cos(OMEGA)));//-(2 * H * Yq * (sin(OMEGA ))); igual es por que yq es 0 IMPORTANTE ESTO POR QUE LO REPITE MAS VECES
    E7 = -(2 * Ya * ab3) + (2 * Yr * ab3) - (2 * H * ab3 * (sin(OMEGA + 60)));
    E8 = -(2 * Xa * ab3) + (2 * Xr * ab3) - (2 * H * ab3 * (cos(OMEGA + 60)));
    E9 = (sq(Xa)) + (sq(Ya)) - (2 * Xa * Xr)- (2 * Ya * Yr) + (sq(Xr)) + (sq(Yr)) + (sq(H)) + (sq(ab3)) - (sq(bc3)) + (2 * Xa * H * (cos((OMEGA + 60)))) + (2 * Ya * H * (sin((OMEGA + 60)))) - (2 * H * Xr * (cos((OMEGA + 60))))-(2 * H * Yr * (sin((OMEGA + 60))));
   
    ///////////// 
    
    E10=(sq(E1)) + (sq(E2)) - (sq(E3));
    E11=(sq(E4)) + (sq(E5)) - (sq(E6));
    E12=(sq(E7)) + (sq(E8)) - (sq(E9));
    
   /*if (E10<0)
    {
      E10=-E10;
    }
    else
    {
      E10=E10;
    }
    
   if (E11<0)
    {
      E11=-E11;
    }
    else
    {
      E11=E11;
    }
    
   if (E12<0)
    {
      E12=-E12;
    }
    else
    {
      E12=E12;
    }
   

    FI1 =  2 * (atan2((-E1 + (sqrt(E10))) , (-E2 + E3)));
    FI1n=  2 *(atan2((-E1 - (sqrt(E10))) , (-E2 + E3))); 
    FI1 = FI1n; //CON ESTO HARIA QUE CUANDO NO PUEDA GIRAR EN CON CODO ABIERTO GIRE EN CODO CERRADO
    
    FI2 =  2 *(atan2((-E4 + (sqrt(E11))) , (-E5 + E6)));
    FI2n =  2 *(atan2((-E4 - (sqrt(E11))) , (-E5 + E6)));
    FI2 = FI2n;
    
    FI3 =  2 * (atan2((-E7 + (sqrt(E12))) , (-E8 + E9)));
    FI3n = 2 *(atan2((-E7 - (sqrt(E12))) , (-E8 + E9)));
    FI3 = FI3n;
    */
    
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
  
  if (isnan(FI1) or isnan(FI2) or isnan(FI3))
  {
    
  Serial.println("");
  Serial.println("ERROR: no se puede mover el robot a esa posición");
  Serial.println("");
  
  FI1=FI1comp;
  FI2=FI2comp;
  FI3=FI3comp;

  FI1final=FI1comp-FI1;
  FI2final=FI2comp-FI2;
  FI3final=FI3comp-FI3;

  X0=X0comp;
  Y0=Y0comp;
  OMEGA=OMEGAcomp;
  
  }
  else
  {
    
  FI1final=(FI1comp-(FI1)+((FI1acu)*(1.8/3.8125))) *(3.8125/1.8);
  FI2final=(FI2comp-(FI2)+((FI2acu)*(1.8/3.8125))) *(3.8125/1.8);
  FI3final=(FI3comp-(FI3)+((FI3acu)*(1.8/3.8125))) *(3.8125/1.8);


  FI1comp=(FI1);
  FI2comp=(FI2);
  FI3comp=(FI3);

  }
 


 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 Finalsteps1=round(FI1final);
  FI1acu=FI1final-Finalsteps1;

 Finalsteps2=round(FI2final);
  FI2acu=FI2final-Finalsteps2;

 Finalsteps3=round(FI3final);
  FI3acu=FI3final-Finalsteps3;

          if (Finalsteps3  >=100 or Finalsteps2  >=100 or Finalsteps1 >=100 or Finalsteps3  <=-100 or Finalsteps2  <=-100 or Finalsteps1 <=-100)
            {
               
               Serial.println("////////////////////////////////////////////");
               Serial.println("ERROR: MOVIMIENTO DEMASIADO GRANDE");
               Serial.println("////////////////////////////////////////////");

              while (1) {} //se para el programa
            }
            
           else
           
    {
 
    // Store the target positions in the "gotopostion" array
  gotoposition[0] = Finalsteps1;  // posibilidad 1 3 2
  gotoposition[1] = Finalsteps2;
  gotoposition[2] = Finalsteps3;

  steppersControl.moveTo(gotoposition); // Calculates the required speed for all motors
  steppersControl.runSpeedToPosition(); // Blocks until all steppers are in position

  delay(500);
  Serial.println("////////////////////////////////////////////");

  Serial.print("X0 = ");
  Serial.println(X0);
  Serial.print("Y0 = ");
  Serial.println(Y0);
  Serial.print("OMEGA = ");
  Serial.println(OMEGA);
  Serial.println("");
  Serial.print("(FI1,FI2,FI3) = ");
  Serial.print("(");
  Serial.print(FI1);
  Serial.print(",");
  Serial.print(FI2);
  Serial.print(",");
  Serial.print(FI3);
  Serial.println(")");
  Serial.println("");
  Serial.print("(FI1final,FI2final,Ff3Final) = ");
  Serial.print("(");
  Serial.print(FI1final);
  Serial.print(",");
  Serial.print(FI2final);
  Serial.print(",");
  Serial.print(FI3final);
  Serial.println(")");
  Serial.println("");
  Serial.print("(Finalsteps1,Finalsteps2,Finalsteps3) = ");
  Serial.print("(");
  Serial.print(Finalsteps1);
  Serial.print(",");
  Serial.print(Finalsteps2);
  Serial.print(",");
  Serial.print(Finalsteps3);
  Serial.println(")");
    Serial.println("");
  Serial.print("(FI1comp,FI2comp,FI3comp) = ");
  Serial.print("(");
  Serial.print(FI1comp);
  Serial.print(",");
  Serial.print(FI2comp);
  Serial.print(",");
  Serial.print(FI3comp);
  Serial.println(")");
  Serial.println("");
  Serial.print("(FI1acu,FI2acu,FI3acu) = ");
  Serial.print("(");
  Serial.print(FI1acu);
  Serial.print(",");
  Serial.print(FI2acu);
  Serial.print(",");
  Serial.print(FI3acu);
  Serial.println(")");

  Serial.println("////////////////////////////////////////////");
 }
}
